freeslot(
"MT_DSNSHOCKW",
"S_DSN_SHOCKW1",
"S_NILLY_GPFLWR"
)

local WaterFactor = function(mo, val, dir)
 if mo and mo.valid
  local water = 0
  local water2
  
  if dir == nil or dir == 0 //vertical factor
   water = ((mo.eflags&MFE_UNDERWATER) or P_IsObjectInGoop(mo) or mo.player and (mo.player.powers[pw_spacetime])) and 2 or 1
   water2 = ((mo.eflags&MFE_UNDERWATER) or P_IsObjectInGoop(mo) or mo.player and (mo.player.powers[pw_spacetime])) and 3 or 1
  elseif dir == 1 //horizontal factor
   water = 1
   water2 = ((mo.eflags&MFE_UNDERWATER) or P_IsObjectInGoop(mo) or mo.player and (mo.player.powers[pw_spacetime])) and 2 or 1
  end
  
  local rval = (water*val)/water2
  return rval
 else
  return
 end
end


local NILLYFLYTICS = 35
local WATERFACTOR = 8/9
local SUPERFACTOR = 4/3
local sdrisetime = 21

states[S_NILLY_GPFLWR] = {
		sprite = SPR_CABR,
		frame = A,
		var1 = 0,
		var2 = 0,
		tics = 2,
		nextstate = S_NULL
}

mobjinfo[MT_DSNSHOCKW] = {
  mapnum = -1,
  spawnstate = S_DSN_SHOCKW1,
  flags = MF_MISSILE|MF_NOCLIPHEIGHT,
  spawnhealth = 1000,
  height = 21*FRACUNIT,
  radius = 15*FRACUNIT,
  speed = 25*FRACUNIT,
  reactiontime = TICRATE,
  deathstate = 	S_NULL,
  seestate = S_DSN_SHOCKW1,
  seesound = sfx_none,
  deathsound = sfx_none
}

states[S_DSN_SHOCKW1] = {
	sprite = SPR_PUMA,
	frame = FF_FULLBRIGHT,
	tics = -1,
	var1 = 1,
	var2 = 3,
	nextstate = S_DSN_SHOCKW1
}

local DoSpinDashDust = function(player, speed) // From the source code!
	local mo = player.mo
	local prandom = {}
	for i = 0, (leveltime%7) >> 1 // 1, 2, 3 or 4 particles
		local particle = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_SPINDUST)

		if mo.eflags & (MFE_TOUCHWATER|MFE_UNDERWATER) // overrides fire version
			particle.state = S_SPINDUST_BUBBLE1
		elseif player.powers[pw_shield] == SH_ELEMENTAL
			particle.state = S_SPINDUST_FIRE1
		end

		particle.target = mo
		particle.destscale = (mo.destscale << 1)/3
		P_SetScale(particle, particle.destscale)
		if mo.eflags & MFE_VERTICALFLIP // readjust z position if needed
			particle.z = mo.z + mo.height - particle.height
		end
		prandom[0] = P_RandomFixed()<<2 // P_RandomByte()<<10
		prandom[1] = P_RandomRange(-30, 30) // P_RandomRange(-ANG30/FRACUNIT, ANG30/FRACUNIT)*FRACUNIT
		prandom[2] = P_RandomFixed()<<3 // P_RandomByte()<<11
		P_SetObjectMomZ(particle, speed/50 + prandom[0], false)
		P_InstaThrust(particle,
				player.drawangle + prandom[1]*ANG1,
				-FixedMul(speed/12 + FRACUNIT + prandom[2], mo.scale))
		P_TryMove(particle, particle.x + particle.momx, particle.y + particle.momy, true)
	end
end

local function CheckAndCrumble(mo, sec)
  for fof in sec.ffloors()
    if not (fof.flags & FF_EXISTS) continue end -- Does it exist?
    if not (fof.flags & FF_BUSTUP) continue end -- Is it bustable?
    
    if mo.z + mo.height < fof.bottomheight continue end -- Are we too low?
    if mo.z > fof.topheight+FRACUNIT continue end -- Are we too high?

    -- Check for whatever else you may want to    

    EV_CrumbleChain(fof) -- Crumble
  end
end

local ResetNilSDVar = function(player)
  //print("reset spin drill variables")
  player.spindrill = false
  player.spdrl_rise = false
  player.spdrl_time = nillyflytics
  player.sdrisetime = sdrisetime
  player.sdgroundpound = 0
end


addHook("PlayerThink", function(player)
	if player.mo.skin != "nilly"
		return
	end
	
	if player.mo.mpspin ~= nil and (player.cmd.buttons & BT_USE)
		player.mo.mpspin = $ + 1
	else player.mo.mpspin = 0
	end
end)

local SKIN = "nilly"

local function DoFireDust(player, speed) // From the source code!
	local mo = player.mo
	local prandom = {}
	for i = 0, (leveltime%7) >> 1 // 1, 2, 3 or 4 particles
		local particle = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_SPINDUST)
   particle.state = S_SPINDUST_FIRE1
		if mo.eflags & (MFE_TOUCHWATER|MFE_UNDERWATER) // overrides fire version
			particle.state = S_SPINDUST_BUBBLE1
		end

		particle.target = mo
		particle.destscale = (mo.destscale << 1)/3
		P_SetScale(particle, particle.destscale)
		if mo.eflags & MFE_VERTICALFLIP // readjust z position if needed
			particle.z = mo.z + mo.height - particle.height
		end
		prandom[0] = P_RandomFixed()<<2 // P_RandomByte()<<10
		prandom[1] = P_RandomRange(-30, 30) // P_RandomRange(-ANG30/FRACUNIT, ANG30/FRACUNIT)*FRACUNIT
		prandom[2] = P_RandomFixed()<<3 // P_RandomByte()<<11
		P_SetObjectMomZ(particle, speed/50 + prandom[0], false)
		P_InstaThrust(particle,
				player.drawangle + prandom[1]*ANG1,
				-FixedMul(speed/12 + FRACUNIT + prandom[2], mo.scale))
		P_TryMove(particle, (particle.x + particle.momx), (particle.y + particle.momy), true)
	end
end

addHook("PlayerThink", function(player)
    if player.mo.skin == SKIN then
        if player.divedelay == nil then player.divedelay = 0
        elseif player.divedelay > 0 then player.divedelay = $ - 1 end
	end
end)

local DoSpinDashDust = function(player, speed) // From the source code!
	local mo = player.mo
	local prandom = {}
	for i = 0, (leveltime%7) >> 1 // 1, 2, 3 or 4 particles
		local particle = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_SPINDUST)

		if mo.eflags & (MFE_TOUCHWATER|MFE_UNDERWATER) // overrides fire version
			particle.state = S_SPINDUST_BUBBLE1
		elseif player.powers[pw_shield] == SH_ELEMENTAL
			particle.state = S_SPINDUST_FIRE1
		end

		particle.target = mo
		particle.destscale = (mo.destscale << 1)/3
		P_SetScale(particle, particle.destscale)
		if mo.eflags & MFE_VERTICALFLIP // readjust z position if needed
			particle.z = mo.z + mo.height - particle.height
		end
		prandom[0] = P_RandomFixed()<<2 // P_RandomByte()<<10
		prandom[1] = P_RandomRange(-30, 30) // P_RandomRange(-ANG30/FRACUNIT, ANG30/FRACUNIT)*FRACUNIT
		prandom[2] = P_RandomFixed()<<3 // P_RandomByte()<<11
		P_SetObjectMomZ(particle, speed/50 + prandom[0], false)
		P_InstaThrust(particle,
				player.drawangle + prandom[1]*ANG1,
				-FixedMul(speed/12 + FRACUNIT + prandom[2], mo.scale))
		P_TryMove(particle, particle.x + particle.momx, particle.y + particle.momy, true)
	end
end

freeslot(
"MT_NFIREB",
"S_PLAY_PUNCH1",
"S_PLAY_PUNCH2",
"S_PLAY_PUNCHEND"
)

mobjinfo[MT_NFIREB] = {
	doomednum = -1,
	spawnstate = S_FIREBALL,
	spawnhealth = 1000,
	seestate = S_NULL,
	seesound = sfx_mario7,
	attacksound = sfx_none,
	painstate = S_NULL,
	painsound = sfx_none,
	meleestate = S_NULL,
	misslestate = S_NULL,
	deathstate = S_NULL,
	xdeathstate = S_NULL,
	deathsound = sfx_corkh,
	activesound = sfx_none,
	raisestate = S_NULL,
	reaciontime = 0,
	painchance = 255,
	speed = 0,
	radius = 8*FRACUNIT,
	height = 16*FRACUNIT,
	dispoffset = 0,
	mass = 4,
	damage = 0,
	flags = MF_BOUNCE|MF_MISSILE|MF_NOBLOCKMAP|MF_FIRE|MF_NOGRAVITY
}

states[S_PLAY_PUNCH1] = {
		frame = FF_SPR2ENDSTATE|SPR2_TWIN,
		sprite = SPR_PLAY,
		var1 = S_PLAY_PUNCHEND,
		var2 = 11,
		tics = 2,
		nextstate = S_PLAY_PUNCH1
}

states[S_PLAY_PUNCH2] = {
		sprite = SPR_PLAY,
		frame = FF_SPR2ENDSTATE|SPR2_CLMB,
		var1 = S_PLAY_PUNCHEND,
		var2 = 11,
		tics = 2,
		nextstate = S_PLAY_PUNCH2
}

states[S_PLAY_PUNCHEND] = {
		sprite = SPR_PLAY,
		frame = SPR2_MLEL,
		var1 = 0,
		var2 = 0,
		tics = 4,
		nextstate = S_PLAY_STND
}

freeslot(
"S_NILLY_HOMEDASH",
"S_NILLY_AIRDASH",
"S_PLAY_FALLCURL",
"S_NILLY_BOUNCE",
"S_NILLY_GPJUMP",
"S_NILLY_GPLAND",
"S_NILLY_REBOUND",
"S_NILLY_FLY",
"S_NILLY_FLOAT",
"S_NILLY_DROPDASH",
"S_NILLY_FLY_DASH",
"S_NILLY_FLY_DASH2",
	"sfx_nildd"
)

states[S_NILLY_AIRDASH] = {
		sprite = SPR_PLAY,
		frame = SPR2_ROLL,
		var1 = 0,
		var2 = 0,
		tics = 1,
		nextstate = S_NILLY_AIRDASH
}

states[S_NILLY_HOMEDASH] = {
		sprite = SPR_PLAY,
		frame = SPR2_FIRE,
		var1 = 0,
		var2 = 0,
		tics = 2,
		nextstate = S_NILLY_HOMEDASH
}

states[S_PLAY_FALLCURL] = {
		sprite = SPR_PLAY,
		frame = FF_SPR2ENDSTATE|SPR2_ROLL,
		var1 = S_PLAY_FALL,
		var2 = 0,
		tics = 2,
		nextstate = S_PLAY_FALLCURL
}

states[S_NILLY_BOUNCE] = {
		sprite = SPR_PLAY,
		frame = SPR2_BNCE,
		var1 = 0,
		var2 = 0,
		tics = 2,
		nextstate = S_NILLY_BOUNCE
}

states[S_NILLY_REBOUND] = {
		sprite = SPR_PLAY,
		frame = SPR2_ROLL,
		var1 = 0,
		var2 = 0,
		tics = 18,
		nextstate = S_PLAY_FALLCURL
}

states[S_NILLY_GPJUMP] = {
		sprite = SPR_PLAY,
		frame = A|SPR2_MLEE,
		var1 = 0,
		var2 = 0,
		tics = -1,
		nextstate = S_NILLY_GPJUMP
}

states[S_NILLY_GPLAND] = {
		sprite = SPR_PLAY,
		frame = SPR2_MLEL,
		var1 = 0,
		var2 = 0,
		tics = 12,
		nextstate = S_PLAY_STND
}

states[S_NILLY_FLOAT] = {
		sprite = SPR_PLAY,
		frame = SPR2_GLID,
		var1 = 0,
		var2 = 0,
		tics = 2,
		nextstate = S_NILLY_FLOAT
}

states[S_NILLY_FLY] = {
		sprite = SPR_PLAY,
		frame = SPR2_FLY_,
		var1 = 0,
		var2 = 0,
		tics = 3,
		nextstate = S_NILLY_FLY
}

states[S_NILLY_FLY_DASH] = {
		sprite = SPR_PLAY,
		frame = FF_SPR2SUPER|SPR2_DASH,
		var1 = 0,
		var2 = 0,
		tics = 1,
		nextstate = S_NILLY_FLY_DASH
}

states[S_NILLY_FLY_DASH2] = {
		sprite = SPR_PLAY,
		frame = SPR2_DASH,
		var1 = 0,
		var2 = 0,
		tics = 1,
		nextstate = S_NILLY_FLY_DASH2
}

states[S_NILLY_DROPDASH] = {
		sprite = SPR_PLAY,
		frame = SPR2_CLMB,
		var1 = 0,
		var2 = 0,
		tics = 1,
		nextstate = S_NILLY_DROPDASH
}

local function comet(player, color)
	local center = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z+player.mo.height/2, MT_THOK)
	center.target = player.mo
	center.scale = player.mo.scale/3
	if color
   center.color = color
 else
   center.color = player.mo.color
 end
	local radiusx = P_ReturnThrustX(player.mo, player.mo.angle, -player.mo.radius)
	local radiusy = P_ReturnThrustY(player.mo, player.mo.angle, -player.mo.radius)
	local factorx = P_ReturnThrustX(player.mo, player.mo.angle+ANGLE_90, FRACUNIT)
	local factory = P_ReturnThrustY(player.mo, player.mo.angle+ANGLE_90, FRACUNIT)
	local i = -1
	while (i < 2)
		local offseth = i*P_ReturnThrustX(player.mo, ANG20*leveltime, player.mo.radius)
		local offsetv = i*P_ReturnThrustY(player.mo, ANG20*leveltime, player.mo.radius)
		local x = player.mo.x + radiusx + FixedMul(offseth, factorx)
		local y = player.mo.y + radiusy + FixedMul(offseth, factory)
		local z = player.mo.z + (player.mo.height >> 1) + offsetv
		local trail = P_SpawnMobj(x, y, z, MT_THOK)
		trail.target = player.mo
		trail.scale = player.mo.scale/3
   if color
		trail.color = color
   else
   trail.color = player.mo.color
   end
		i = $+2
	end
end

addHook("PlayerSpawn", function(player)
 if player and player.mo and player.mo.valid
   player.nillygroundpound = 0
   player.nillygptimer1 = 0
	player.npunch = false
	player.npunchdelay = 0
	player.nspinheld = 0
	player.domegaslam = false
  
  player.spdrl_rise = false
  player.spdrl_time = nillyflytics
  player.sdrisetime = sdrisetime
  
  if player.nillyarms ~= nil
   player.nillyarms.reset = false
   player.nillyarms.launchtime = 0
   player.nillyarms.launchstate = 0
  else
   player.nillyarms = {}
  end
 else
  return
 end
end)

addHook("MapLoad", function(S0)
	if OLDC ~= nil
		if OLDC.SkinFullNames[SKIN] ~= nil then return end
		OLDC.SetSkinFullName(SKIN, "Nilly the Explorer")
	else
		return
	end
end)

addHook("JumpSpecial", function(player)
	if player.mo and player.mo.valid and not PSO
		if player.mo.skin ~= SKIN
			return
		end
		
		if player.playerstate ~= PST_LIVE or player.exiting or player.charability2 ~= CA2_SPINDASH or player.mo.state == S_NILLY_GPLAND or player.mo.state == S_PLAY_MELEE_LANDING or player.npunch
			return
		end
		
		if player.mo.state == S_PLAY_MELEE_LANDING
			player.pflags = $ & ~PF_JUMPED
			P_DoJump(player)
			return true
		end
	else
		return
	end
end)


local TWIRLWINDTIME = TICRATE * 8/9
local MAXTWTIME = 21 //you stupid

local NILLYGP1 = S_PLAY_SPINDASH
local NILLYGP2 = S_PLAY_MELEE
local NILLYGP3 = S_PLAY_MELEE_FINISH
local NILLYGPLAND = S_PLAY_MELEE_LANDING

freeslot("S_NILLY_FLIGHT", "S_NILLY_SLIDE")

states[S_NILLY_FLIGHT] = {
		sprite = SPR_PLAY,
		frame = SPR2_FLY_,
		var1 = 0,
		var2 = 0,
		tics = 1,
		nextstate = S_NILLY_FLIGHT
}
states[S_NILLY_SLIDE] = {
		sprite = SPR_PLAY,
		frame = SPR2_GLID,
		var1 = 0,
		var2 = 0,
		tics = 2,
		nextstate = S_NILLY_SLIDE
}


addHook("AbilitySpecial", function(player)
	if (player.mo and player.mo.valid)
	and player.mo.skin == SKIN
		local mo = player.mo
		local cmd = player.cmd
		local skinvar = skins[player.mo.skin]
		
		if (player.pflags&PF_JUMPDOWN) or player.charability ~= skinvar.ability or player.charability == CA_NONE then return end
		
		if not (player.pflags&PF_THOKKED) or not player.Nhasusedtw and player.mo.state ~= S_PLAY_MELEE and player.mo.state ~= S_PLAY_MELEE_FINISH
			player.powers[pw_strong] = STR_ANIM|STR_CEILING|STR_ATTACK
			//P_SetObjectMomZ(mo, mo.momz*P_MobjFlip(mo) + 6*FRACUNIT)
	
			//P_SpawnThokMobj(player)
			if not (player.pflags&PF_THOKKED)
			S_StartSound(mo, sfx_s3kc6s)
			end
			
			S_StartSound(mo, sfx_s3kdbl)
			S_StartSound(mo, sfx_s3ka0)
			//S_StartSound(player.mo, sfx_kc55)
			//S_StartSound(player.mo, sfx_cdfm66)
			
			player.backflip = false
			player.backflippin = false
			mo.state = S_NILLY_FLIGHT
			player.twirlwindstate = 3
     player.Nhasusedtw = true
			player.twtime = TWIRLWINDTIME*2

			local dashspd = (player.speed <= 45*FRACUNIT) and player.speed + FRACUNIT or player.speed
   if (player.cmd.forwardmove ~= 0 or player.cmd.sidemove ~= 0 or player.cmd.buttons&BT_SPIN)
   P_InstaThrust(player.mo, player.mo.angle, max(dashspd, skinvar.runspeed/2))
   else
			P_SetObjectMomZ(player.mo, (CBW_Battle) and FRACUNIT*3 or FRACUNIT*5, true)
   end
   player.drawangle = R_PointToAngle2(0,0, player.mo.momx, player.mo.momy)

			player.pflags = $|PF_THOKKED & ~PF_STARTJUMP
	
			/*return true
		elseif (player.pflags&PF_SPINNING) 
			if player.dashcount < 1
				player.mo.state = S_PLAY_ROLL
				player.mo.momz = -$ * (6/6)
				P_SetObjectMomZ(mo, 7*FRACUNIT)
				P_Thrust(player.mo, player.mo.angle, FRACUNIT*5)
				player.dashcount = ($ ~= nil) and $ + 1 or 1
				S_StartSound(player.mo, sfx_s3ka6)
				P_SpawnThokMobj(player)
				
				for i = 1, 10 do //yo mama
					local dust = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPINDUST)
					P_Thrust(dust, player.mo.angle + (ANG1 * 36 * i), player.mo.scale * -20)
					P_SetObjectMomZ(dust, 5*FRACUNIT/3, true)
					if (player.mo.eflags & MFE_VERTICALFLIP) // readjust z position if needed
						dust.z = player.mo.z + player.mo.height - dust.height
					end
					if player.mo.eflags & (MFE_TOUCHWATER|MFE_UNDERWATER) // overrides fire version
						dust.state = S_SPINDUST_BUBBLE1
					elseif player.powers[pw_shield] == SH_FLAMEAURA
						dust.state = S_SPINDUST_FIRE1
					end
				end
			end*/
			return true
		end
	else
		return
	end
end)

addHook("JumpSpinSpecial", function(player)
 if player.mo and player.mo.valid
 and player.mo.skin == SKIN
 
	if player.charability2 == CA2_NONE then return end
  
  if not (player.pflags&PF_SPINDOWN) and not (player.pflags&PF_THOKKED) and player.grabberpound == 0
   player.grabberpound = 1
    player.powers[pw_strong] = STR_ANIM|STR_SPRING|STR_SPIKE|STR_FLOOR|STR_ATTACK
   player.pflags = $|PF_THOKKED
   player.mo.state = NILLYGP1
   S_StartSound(player.mo, sfx_nildd)
   P_SetObjectMomZ(player.mo, min(8*FRACUNIT, player.mo.momz*P_MobjFlip(player.mo) - FRACUNIT*5), false)
   return true
  end
 else
  return
 end
end)

addHook("AbilitySpecial", function(player)
 if player.mo and player.mo.valid
 and player.mo.skin == SKIN
  
  if not (player.pflags&PF_JUMPDOWN) and player.grabberpound
   player.grabberpound = 0
   player.charability2 = CA2_MELEE
   player.pflags = $|PF_THOKKED|PF_STARTJUMP & ~PF_SPINNING
   player.mo.state = S_PLAY_TWINSPIN
   player.Nhasusedtw = false
    player.powers[pw_strong] = STR_ANIM|STR_SPRING|STR_BUST|STR_ATTACK
	
			/*player.twirlwindstate = 3
			player.twtime = TWIRLWINDTIME*2*/
   S_StopSoundByID(player.mo, sfx_nildd)
   //S_StartSound(player.mo, sfx_zoom)
   //S_StartSound(mo, sfx_s3kc6s)
			S_StartSound(player.mo, sfx_thok)
			//S_StartSound(mo, sfx_s3ka0)
			

   local dashspd = (player.speed <= 45*FRACUNIT) and player.speed + FRACUNIT*10 or player.speed
   if (player.cmd.forwardmove ~= 0 or player.cmd.sidemove ~= 0 and player.cmd.buttons&BT_SPIN)
   P_InstaThrust(player.mo, player.mo.angle, max(dashspd, player.normalspeed))
   player.drawangle = player.mo.angle
   end

   P_SetObjectMomZ(player.mo, max(-player.mo.momz*P_MobjFlip(player.mo)/3, player.mo.momz*P_MobjFlip(player.mo)), false)
   P_SetObjectMomZ(player.mo, 5*FRACUNIT, true)
   return true
  end
 else
  return
 end
end)

addHook("SpinSpecial", function(player)
 if player.mo and player.mo.valid
 and player.mo.skin == SKIN
		local skinvar = skins[player.mo.skin]
		
		if player.charability2 == CA2_NONE then return end
  
  if not (player.pflags&PF_SPINNING) and (P_IsObjectOnGround(player.mo) or (player.mo.eflags&MFE_JUSTHITFLOOR))
   if player.speed >= 5*FRACUNIT
    if not ((player.pflags&PF_SPINDOWN) and not (player.mo.eflags&MFE_JUSTHITFLOOR) and not (player.speed <= FRACUNIT)) 
    player.mo.state = S_NILLY_SLIDE
	
	local lemax = (CBW_Battle) and 8*FRACUNIT or player.maxdash //stupid ahh battle speed
	local dshspeed = (player.speed >= 42*player.mo.scale) and FixedHypot(player.mo.momx-player.cmomx, player.mo.momy-player.cmomy) or max(lemax*2, player.speed + FRACUNIT*5)
	P_InstaThrust(player.mo, player.mo.angle, dshspeed)
	
    player.pflags = $|PF_SPINNING
    if (player.mo.eflags&MFE_JUSTHITFLOOR) and not (player.pflags&PF_SPINNING)
    S_StartSound(player.mo, sfx_spin)
    elseif P_IsObjectOnGround(player.mo)
    S_StartSound(player.mo, sfx_s3k47)
	S_StartSound(player.mo, sfx_zoom)
    end
    end
   else
    if (player.cmd.forwardmove ~= 0 or player.cmd.sidemove ~= 0) or player.spindelay and not (player.pflags&PF_SPINDOWN)
     player.spindelay = 0
     local usetheability = 0


     if usetheability == 0
		if not ((player.pflags&PF_SPINDOWN) and not ((player.mo.eflags&MFE_JUSTHITFLOOR) and (player.speed < FRACUNIT))) 
      player.mo.state = S_PLAY_ROLL
      player.pflags = $|PF_SPINNING
      P_InstaThrust(player.mo, player.mo.angle, 5*skinvar.runspeed/7)
      S_StartSound(player.mo, sfx_zoom)
	  end
      return true
     else
      /*player.mo.state = S_PLAY_MELEE
      InstaThrust(player.mo, player.mo.angle, player.mindash)
      P_SetObject*/
      return false
     end
    else
    player.mo.state = S_PLAY_GLIDE_LANDING
    player.pflags = $|PF_STASIS
     player.spindelay = 10
    //print("crouching")
    end
   end
   return true
  end
 else
  return
 end
end)

addHook("PlayerThink", function(player)
 if player.mo and player.mo.valid
 and player.mo.skin == SKIN
		local p = player
		local mo = player.mo
		local cmd = player.cmd
		local skinvar = skins[player.mo.skin]

   if player.spindelay ~= nil
    player.spindelay = max($-1, 0)
   else
    player.spindelay = 0
   end

		if player.justspindashed == nil
			player.justspindashed = 0
		elseif (player.pflags&PF_SPINNING) and not (player.pflags&(PF_STARTDASH)) and (P_IsObjectOnGround(mo) or player.wasrunningonwater) //and player.justspindashed >= 0
			player.justspindashed = $ - 1
		else
			player.justspindashed = 16
		end


   if (GS_RAILS_SKINS and not GS_RAILS_SKINS["nilly"]) //and (player.mo.GSgrind)
    GS_RAILS_SKINS["nilly"] = {}
    local SKIN = GS_RAILS_SKINS["nilly"]

    SKIN["S_SKIN"] = {
	  STARTMODIFIER = 5,
	  SIDEHOPARC = 30,
    SIDEFLIP = SPR2_JUMP,
	  AIRDRAG = 40,
	  LAUNCHPOWER = 10,
	  ACCELSPEED = 30,
	  MINSPEED = -10,
	  ACCELCAP = 39
     }
	 
	 /*SKIN["CustomAnim"] = function(p, mo, GS, rail, POSTTHINK, ANIMCALL)
		if (POSTTHINK!=true) return false end 
		
		if mo.GSgrind and GS.grinding and mo.state == S_PLAY_GSGRINDING and not ((mo.sprite2 & ~FF_SPR2SUPER)==SPR2_ROLL or GS.forcesprite==SPR2_ROLL)
			if p.dschargestate == 1
				mo.state = S_PHOENIX_ERGRIND
			elseif GS.railspin or p.dschargestate
				mo.state = S_PHOENIX_CROUCHGRIND
			end
		end
	 end*/

   end

   if player.Nhasusedtw == nil then player.Nhasusedtw = false end
		
		
  if (player.mo.state == S_PLAY_SPRING or player.mo.state == S_PLAY_FALL) and ((player.mo.eflags&MFE_SPRUNG) or (player.powers[pw_carry] == STR_FAN or player.powers[pw_carry] == 3888)) or (not (player.pflags&PF_JUMPED) and not (player.powers[pw_carry]) and not ((mo.eflags&MFE_JUSTHITFLOOR) or P_IsObjectOnGround(player.mo)))
   player.pflags = $|PF_JUMPED & ~(PF_THOKKED|PF_STARTJUMP)
   player.Nhasusedtw = false
  end

  if (player.mo.state == NILLYGPLAND or player.mo.state == S_PLAY_GLIDE_LANDING) and (P_IsObjectOnGround(player.mo) or (player.mo.eflags&MFE_JUSTHITFLOOR))
   player.pflags = $|PF_STASIS & ~PF_JUMPSTASIS
   player.mo.friction = FRACUNIT*38/39
  end
  
  if player.mo.state == S_PLAY_MELEE or player.mo.state == S_PLAY_MELEE_FINISH
   player.Nhasusedtw = true
  end
  
  if player.mo.state == S_PLAY_TWINSPIN
  player.powers[pw_strong] = STR_ANIM|STR_SPRING|STR_BUST|STR_ATTACK
  end
		
		if (player.mo.state == S_PLAY_ROLL and (not player.justspindashed) or player.mo.state == S_PLAY_SWIM) //stops these animations from playing while spinning/sliding
			and not (player.pflags&PF_JUMPED) and (player.pflags&PF_SPINNING)
			and P_IsObjectOnGround(player.mo) 
			and not player.powers[pw_carry]
				player.mo.state = S_NILLY_SLIDE
				player.panim = PA_ROLL
		end
  

		if player.twirlwindstate == nil
			player.twirlwindstate = 0
			player.twtime = 0
		end
		
		if player.twirlwindstate == 1
			if (player.mo.eflags&MFE_JUSTHITFLOOR) 
					player.twirlwindstate = 0
					P_SetObjectMomZ(player.mo, 12*FRACUNIT)
					player.mo.state = S_PHOENIX_HUMMINGTOP
					player.powers[pw_strong] = STR_NONE
					player.pflags = $|PF_JUMPED & ~(PF_THOKKED|PF_STARTDASH|PF_SPINNING)
					S_StartSound(player.mo, sfx_boingf)
					//P_InstaThrust(player.mo, player.mo.angle, max(player.runspeed, player.speed))
				return
			end
			player.mo.state = S_NILLY_FLIGHT
			player.mo.momz = $ * 88/100
			player.twtime = min($ + 1, MAXTWTIME)
			player.powers[pw_strong] = STR_ANIM|STR_UPPER|STR_BUST|STR_PUNCH|STR_TAIL
		
			if not (player.pflags&PF_JUMPDOWN)
				player.twirlwindstate = 2
				P_SetObjectMomZ(player.mo, FRACUNIT*10 + (player.twtime * FRACUNIT / 8))
				S_StartSound(player.mo, sfx_kc5b)
				player.mo.momx = $ * 88/70
				player.mo.momy = $ * 88/70
				player.mo.state = S_PHOENIX_YAY
				player.twtime = max(8, $*2/3 + 2)
			end
		end
		
		if player.twirlwindstate == 2
			player.twtime = max($ - 1, 0)
			P_SetObjectMomZ(player.mo, -P_GetMobjGravity(player.mo)/2, true)
			if not player.twtime or player.mo.state ~= S_PHOENIX_YAY
				player.twirlwindstate = 0
				if player.mo.state == S_PHOENIX_YAY
					player.mo.state = S_PLAY_FALL
					//S_StartSound(player.mo, sfx_cdfm65)
				end
			end
		end
  
   //we using this one
		if player.twirlwindstate == 3
			if not (player.mo.eflags & MFE_UNDERWATER)
				if (mo.momz*P_MobjFlip(mo) >= FRACUNIT or (cmd.buttons&BT_SPIN)) and not (mo.eflags&MFE_UNDERWATER)
					player.twtime = max($-2, 0)
				else
					player.twtime = (cmd.buttons&BT_SPIN) and max($ - 3, 0) or max($ - 1, 0)
				end
			else
				player.twtime = max($, NILLYFLYTICS*3/2) //refill
			end
			player.powers[pw_strong] = STR_ANIM|STR_CEILING|STR_ATTACK|STR_SPIKE //i fucking hate spikes

			if not player.yaN_dashmode
				if player.isxmomentum
					player.fakenormalspeed = (mo.eflags&MFE_UNDERWATER) and 28*FRACUNIT or 36*FRACUNIT
				else
					player.normalspeed = (mo.eflags&MFE_UNDERWATER) and 28*FRACUNIT or 36*FRACUNIT
				end
			end

			if not player.dsN_storedfactor
				player.dsN_storedfactor = player.thrustfactor
			end
  
			player.thrustfactor = player.dsN_storedfactor * 9/8
   
			if not (player.twtime) or (mo.state ~= S_NILLY_FLIGHT and mo.state ~= S_NILLY_FLY_DASH and mo.state ~= S_NILLY_FLY_DASH2) or not (cmd.buttons&BT_JUMP) or player.powers[pw_carry]
				player.twirlwindstate = 0
				player.twtime = 0
				player.powers[pw_strong] = STR_NONE
				S_StopSoundByID(mo, sfx_s3kdbl)
				player.pflags = $ & ~PF_CANCARRY

				if not player.yaN_dashmode
					if player.isxmomentum
						player.fakenormalspeed = skinvar.normalspeed
					else
						player.normalspeed = skinvar.normalspeed
					end
				end
				player.thrustfactor = player.dsN_storedfactor
				player.dsN_storedfactor = nil


				if (mo.state == S_NILLY_FLIGHT or mo.state == S_NILLY_FLY_DASH or mo.state == S_NILLY_FLY_DASH2)
					mo.state = S_PLAY_FALL
					local ghost = P_SpawnGhostMobj(mo)
					ghost.fuse = 10
					//P_SetObjectMomZ(mo, max(mo.momz*P_MobjFlip(mo) + 2*FRACUNIT, mo.momz*P_MobjFlip(mo) * 4/5))

					//S_StartSound(mo, sfx_kc5b)
					S_StartSound(mo, sfx_s3k82)
				elseif (player.mo.eflags&MFE_JUSTHITFLOOR)
					if (player.cmd.buttons&BT_SPIN) and player.speed > 5*FRACUNIT 
						player.mo.state = S_PLAY_GLIDE
						player.pflags = $|PF_SPINNING & ~(PF_THOKKED|PF_NOJUMPDAMAGE|PF_JUMPED)
						//P_InstaThrust(player.mo, player.mo.angle, max(5*FRACUNIT, player.speed+FRACUNIT*2))
						//S_StartSound(player.mo, sfx_zoom)
					elseif not (player.cmd.buttons&BT_SPIN)
						P_SetObjectMomZ(player.mo, (mo.eflags&MFE_UNDERWATER) and 3*FRACUNIT or 7*FRACUNIT)
						player.mo.state = S_PLAY_ROLL
						player.powers[pw_strong] = STR_NONE
						player.pflags = $|PF_JUMPED & ~(PF_THOKKED|PF_STARTDASH|PF_SPINNING)
						S_StartSound(player.mo, sfx_s3k44)
						//P_InstaThrust(player.mo, player.mo.angle, max(player.runspeed, player.speed))
					end
				end
				//end
			else
			
			
			
				if (cmd.buttons&BT_SPIN) or (cmd.forwardmove ~= 0 or cmd.sidemove ~= 0)
					if (player.speed <= player.normalspeed + FRACUNIT*10 and (cmd.buttons&BT_SPIN))// or player.speed < player.normalspeed + FRACUNIT) and (player.cmd.forwardmove ~= 0 or player.cmd.sidemove ~= 0)
						local ang = (player.cmd.angleturn<<16) + R_PointToAngle2(0,0,player.cmd.forwardmove*FRACUNIT,-player.cmd.sidemove*FRACUNIT)
						P_Thrust(player.mo, ang, FRACUNIT/2)
						player.thrustfactor = player.dsN_storedfactor * 5/4
						player.drawangle = ang //R_PointToAngle2(0,0,player.mo.momx,player.mo.momy)
					end

					S_StartSound(player.mo, sfx_putput)
				
					if player.isxmomentum
						player.fakenormalspeed = max($, 38*FRACUNIT)
					else
						player.normalspeed = max($, 38*FRACUNIT)
					end	
	
					//player.twtime = TWIRLWINDTIME
	
					if mo.momz*P_MobjFlip(mo) < 10*FRACUNIT
						if (cmd.buttons&BT_SPIN)
							player.drawangle = player.mo.angle
							P_SetObjectMomZ(mo, (mo.eflags&MFE_UNDERWATER) and max(mo.momz*P_MobjFlip(mo) - FRACUNIT*1/7, -12 * FRACUNIT) or max(mo.momz*P_MobjFlip(mo) - FRACUNIT*1/6, -18 * FRACUNIT), false)
						else
							P_SetObjectMomZ(mo, (mo.eflags&MFE_UNDERWATER) and min(mo.momz*P_MobjFlip(mo) + FRACUNIT*1/6, 5* FRACUNIT) or min(mo.momz*P_MobjFlip(mo) + FRACUNIT*2/7, 9* FRACUNIT), false)
							if mo.momz*P_MobjFlip(mo) < FRACUNIT
							P_SetObjectMomZ(mo, max(mo.momz*P_MobjFlip(mo)*90/100, -FRACUNIT*7), false)
							end
						end
					else
						P_SetObjectMomZ(mo, -P_GetMobjGravity(mo)*P_MobjFlip(mo)*1/15, true)
					end
					
					if player.mo.state == S_NILLY_FLIGHT or player.mo.state == S_NILLY_FLY_DASH2 and not (player.cmd.buttons &BT_SPIN)
						player.mo.state = S_NILLY_FLY_DASH
					elseif (player.cmd.buttons &BT_SPIN)
						player.mo.state = S_NILLY_FLY_DASH2
					end
					
					player.spindelay = TICRATE/4
				else
					if not (S_SoundPlaying(player.mo, sfx_putput))
						S_StartSound(player.mo, sfx_putput)
					end
	
					if mo.momz*P_MobjFlip(mo) < 19*FRACUNIT/2
						 P_SetObjectMomZ(mo, (mo.eflags&MFE_UNDERWATER) and min(mo.momz*P_MobjFlip(mo) + FRACUNIT*4/9, 9 * FRACUNIT) or min(mo.momz*P_MobjFlip(mo) + FRACUNIT*5/4, 9 * FRACUNIT), false)
					else
						P_SetObjectMomZ(mo, -P_GetMobjGravity(mo)*P_MobjFlip(mo)*1/15, true)
					end
					
					if (player.mo.state == S_NILLY_FLY_DASH or player.mo.state == S_NILLY_FLY_DASH2) and (player.speed <= player.runspeed/2 or player.spindelay == 0)
						player.mo.state = S_NILLY_FLIGHT
					end
				end

       
				if not (S_SoundPlaying(player.mo, sfx_s3kdbl)) or (S_SoundPlaying(player.mo, sfx_s3kdbs))
					S_StopSoundByID(mo, sfx_s3kdbl)
					S_StopSoundByID(mo, sfx_s3kdbs)
					S_StartSound(player.mo, sfx_s3kdbl)
				end
			
				local ghost = P_SpawnGhostMobj(mo)
				ghost.fuse = 3

				player.pflags = $|PF_CANCARRY
				if player.speed <= 5*FRACUNIT
				player.acceleration = $ * 7/3
				else
				player.acceleration = $ * 8/5
				end
				player.accelstart = $ * 2
			end
		end





  if player.grabberpound == nil //big ground pound table ???
   player.grabberpound = 0
  end
  if player.grabberpound == 1 //currently going up
   if player.mo.state ~= NILLYGP1 or player.powers[pw_carry]
    player.grabberpound = 0
    return
   end
   
    player.powers[pw_strong] = STR_ANIM|STR_SPRING|STR_SPIKE|STR_BUST|STR_ATTACK

   P_SetObjectMomZ(player.mo, -FRACUNIT*1/3, true)
   player.mo.state = NILLYGP1
   player.pflags = $|PF_THOKKED
   if player.mo.momz*P_MobjFlip(player.mo) < FRACUNIT
    player.grabberpound = 2
    //player.mo.state = NILLYGP2
   end
  elseif player.grabberpound == 2
   player.charability2 = CA2_NONE

   if player.mo.momz*P_MobjFlip(player.mo) >= FRACUNIT or P_PlayerInPain(player) or P_IsObjectInGoop(player.mo) or (player.pflags&PF_SLIDING) or player.powers[pw_carry]
    player.grabberpound = 0
    player.charability2 = CA2_MELEE

    if player.mo.state == NILLYGP1 and not P_IsObjectInGoop(player.mo)
     player.mo.state = S_PLAY_SPRING
     player.pflags = $ & ~PF_THOKKED
	 player.mo.momz = FixedMul($, FRACUNIT * 7/8)
    end
   else
    if (P_IsObjectOnGround(player.mo) or (player.mo.eflags&MFE_JUSTHITFLOOR))
     S_StopSoundByID(player.mo, sfx_spndsh)
     player.grabberpound = 0

     if (player.cmd.buttons&BT_SPIN)
		   player.mo.state = S_PLAY_ROLL
				player.pflags = $|PF_SPINNING & ~(PF_THOKKED|PF_NOJUMPDAMAGE|PF_JUMPED|PF_STASIS)
				local dshspeed = (player.speed >= 51*player.mo.scale) and FixedHypot(player.mo.momx-player.cmomx, player.mo.momy-player.cmomy) or max(player.maxdash*2, player.speed + FRACUNIT*5)
				P_InstaThrust(player.mo, player.mo.angle, max(dshspeed, skins[player.mo.skin].runspeed))
			 S_StartSound(player.mo, sfx_zoom)
		  else
      player.pflags = $|PF_JUMPED & ~(PF_THOKKED|PF_STARTJUMP|PF_SPINNING)
	  if (player.cmd.buttons&BT_JUMP)
		player.pflags = $ | PF_STARTJUMP //felt like it
	  end
      S_StartSound(player.mo, sfx_s3k9b)
      S_StartSound(player.mo, sfx_s3k44)
      P_SetObjectMomZ(player.mo, (mo.eflags&MFE_UNDERWATER) and FRACUNIT*11 or FRACUNIT*31/2)
      P_StartQuake(8*FRACUNIT, 5)
      player.mo.state = S_PLAY_ROLL //NILLYGPLAND
      //player.mo.tics = TICRATE/3
     end
     player.charability2 = CA2_MELEE

     return
    else

    player.pflags = $|PF_THOKKED
    P_SetObjectMomZ(player.mo, -FRACUNIT*2/3, true)
    player.mo.state = ($ ~= NILLYGP1) and NILLYGP1 or $
    if player.mo.state == NILLYGP3
     player.mo.frame = 3
    end
    player.powers[pw_strong] = STR_ANIM|STR_SPRING|STR_SPIKE|STR_FLOOR|STR_ATTACK
    end
   end
  end

  if p.mo.state != S_PLAY_MELEE_LANDING --and p.mo.state != S_PLAY_MELEE_FINISH  
			p.amyspeeb = p.speed
		end
		if p.mo.state == S_PLAY_MELEE_LANDING and p.cmd.buttons & BT_JUMP
		 player.pflags = $|PF_JUMPED|PF_STARTJUMP|PF_JUMPDOWN & ~(PF_THOKKED|PF_STASIS)
			if not p.powers[pw_super]
				P_SetObjectMomZ(p.mo, max(p.amyspeeb*2/6, FixedMul(11*FRACUNIT, player.mo.scale)), false)
			else
				P_SetObjectMomZ(p.mo, max(p.amyspeeb*6/10, FixedMul(14*FRACUNIT, player.mo.scale)), false)
			end
			P_InstaThrust(p.mo, p.mo.angle, p.amyspeeb)
			p.mo.state = S_PLAY_ROLL
		end


    if (mo.eflags&MFE_JUSTHITFLOOR) or P_IsObjectOnGround(player.mo)
     player.Nhasusedtw = false
    end
	
	if (mo.eflags&MFE_UNDERWATER) and not player.gotflag then player.powers[pw_underwater] = underwatertics end //cool thing
 else
  return
 end
end)

local function HandleHeight(player)
    if not player.mo then return end
    if player.mo.skin ~= SKIN then return end
    
    if player.mo.state == S_PLAY_GLIDE_LANDING or player.mo.state == NILLYGPLAND
        return P_GetPlayerSpinHeight(player)
    end
end

addHook("PlayerHeight", HandleHeight)
addHook("PlayerCanEnterSpinGaps", HandleHeight)